
// sketchView.cpp : implementation of the CsketchView class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "sketch.h"
#endif

#include "sketchDoc.h"
#include "sketchView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CsketchView

IMPLEMENT_DYNCREATE(CsketchView, CView)

BEGIN_MESSAGE_MAP(CsketchView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CsketchView::OnFilePrintPreview)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_DRAWCOLOR_RED, &CsketchView::OnDrawcolorRed)
	ON_COMMAND(ID_DRAWCOLOR_GREEN, &CsketchView::OnDrawcolorGreen)
	ON_COMMAND(ID_DRAWCOLOR_BLUE, &CsketchView::OnDrawcolorBlue)
	ON_COMMAND(ID_DRAWCOLOR_BLACK, &CsketchView::OnDrawcolorBlack)
	ON_COMMAND(ID_CLEAR, &CsketchView::OnClear)
END_MESSAGE_MAP()

// CsketchView construction/destruction

CsketchView::CsketchView()
	: m_pt(0)
{
	// TODO: add construction code here
	m_butdn = false;
	m_pt = m_ptold = CPoint(0,0);
	m_color = RGB(0,0,0);
}

CsketchView::~CsketchView()
{
}

BOOL CsketchView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CsketchView drawing

void CsketchView::OnDraw(CDC* /*pDC*/)
{
	CsketchDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CsketchView printing


void CsketchView::OnFilePrintPreview()
{
#ifndef SHARED_HANDLERS
	AFXPrintPreview(this);
#endif
}

BOOL CsketchView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CsketchView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CsketchView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CsketchView::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CsketchView::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


// CsketchView diagnostics

#ifdef _DEBUG
void CsketchView::AssertValid() const
{
	CView::AssertValid();
}

void CsketchView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CsketchDoc* CsketchView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CsketchDoc)));
	return (CsketchDoc*)m_pDocument;
}
#endif //_DEBUG


// CsketchView message handlers


void CsketchView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	m_butdn = true;
	m_ptold = point;

	CView::OnLButtonDown(nFlags, point);
}


void CsketchView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	m_butdn = false;

	CView::OnLButtonUp(nFlags, point);
}


void CsketchView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	if (m_butdn){
		pDC = GetDC();
		m_pt = point;
		CPen newPen (PS_SOLID, 1, m_color);
		CPen* pPenOld = pDC->SelectObject (&newPen);
		pDC->MoveTo (m_ptold);
		pDC->LineTo (m_pt);
		//pDC->Rectangle(m_ptold.x, m_ptold.y, m_pt.x, m_pt.y);
		m_ptold = m_pt;
		pDC->SelectObject (pPenOld);
	}

	CView::OnMouseMove(nFlags, point);
}


void CsketchView::OnDrawcolorRed()
{
	// TODO: Add your command handler code here
	m_color = RGB(255,0,0);
}


void CsketchView::OnDrawcolorGreen()
{
	// TODO: Add your command handler code here
	m_color = RGB(0,255,0);
}


void CsketchView::OnDrawcolorBlue()
{
	// TODO: Add your command handler code here
	m_color = RGB(0,0,255);
}


void CsketchView::OnDrawcolorBlack()
{
	// TODO: Add your command handler code here
	m_color = RGB(0,0,0);
}


void CsketchView::OnClear()
{
	// TODO: Add your command handler code here
	Invalidate();
}
